cat140m = {}

function cat140m.prerequisitesPresent(specializations)
     --Vehicle.registerJointType("shovel");
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function cat140m:load(savegame)

    local translationPartNode11 = Utils.indexToObject(self.rootNode, getXMLString(self.xmlFile, "vehicle.translationPart11#index"));
    if translationPartNode11 ~= nil then
        self.translationPart11 = {};
        self.translationPart11.node = translationPartNode11;
        local x, y, z = Utils.getVectorFromString(getXMLString(self.xmlFile, "vehicle.translationPart11#minTrans"));
        self.translationPart11.minTrans = {};
        self.translationPart11.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart11.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart11.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(self.xmlFile, "vehicle.translationPart11#maxTrans"));
        self.translationPart11.maxTrans = {};
        self.translationPart11.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart11.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart11.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart11.transTime = Utils.getNoNil(getXMLString(self.xmlFile, "vehicle.translationPart11#transTime"), 2)*1000;
        self.translationPart11.touchTransLimit = Utils.getNoNil(getXMLString(self.xmlFile, "vehicle.translationPart11#touchTransLimit"), 10);
        self.translationPart11.pivotverin = Utils.indexToObject(self.rootNode, getXMLString(self.xmlFile, "vehicle.plame#pivotverin"));
        self.translationPart11.pivotverin2 = Utils.indexToObject(self.rootNode, getXMLString(self.xmlFile, "vehicle.plame#pivotverin2"));
    end;
    

        local rotationPartNodeplame = Utils.indexToObject(self.rootNode, getXMLString(self.xmlFile, "vehicle.plame#index"));
    if rotationPartNodeplame ~= nil then
        self.plame = {};
        self.plame.node = rotationPartNodeplame;

        local x, y, z = Utils.getVectorFromString(getXMLString(self.xmlFile, "vehicle.plame#minRot"));
        self.plame.minRot = {};
        self.plame.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.plame.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.plame.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(self.xmlFile, "vehicle.plame#maxRot"));
        self.plame.maxRot = {};
        self.plame.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.plame.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.plame.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.plame.rotTime = Utils.getNoNil(getXMLString(self.xmlFile, "vehicle.plame#rotTime"), 2)*1000;


        self.plame.pivotverin = Utils.indexToObject(self.rootNode, getXMLString(self.xmlFile, "vehicle.plame#pivotverin"));
        self.plame.pivotverin2 = Utils.indexToObject(self.rootNode, getXMLString(self.xmlFile, "vehicle.plame#pivotverin2"));
    end;
    
        local rotationPartNoderoueg = Utils.indexToObject(self.rootNode, getXMLString(self.xmlFile, "vehicle.roueg#index"));
    if rotationPartNoderoueg ~= nil then
        self.roueg = {};
        self.roueg.node = rotationPartNoderoueg;

        local x, y, z = Utils.getVectorFromString(getXMLString(self.xmlFile, "vehicle.roueg#minRot"));
        self.roueg.minRot = {};
        self.roueg.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.roueg.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.roueg.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(self.xmlFile, "vehicle.roueg#maxRot"));
        self.roueg.maxRot = {};
        self.roueg.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.roueg.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.roueg.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.roueg.rotTime = Utils.getNoNil(getXMLString(self.xmlFile, "vehicle.roueg#rotTime"), 2)*1000;
        self.roueg.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(self.xmlFile, "vehicle.roueg#touchRotLimit"), 10))
    end;
        local rotationPartNoderoued = Utils.indexToObject(self.rootNode, getXMLString(self.xmlFile, "vehicle.roued#index"));
    if rotationPartNoderoued ~= nil then
        self.roued = {};
        self.roued.node = rotationPartNoderoued;

        local x, y, z = Utils.getVectorFromString(getXMLString(self.xmlFile, "vehicle.roued#minRot"));
        self.roued.minRot = {};
        self.roued.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.roued.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.roued.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(self.xmlFile, "vehicle.roued#maxRot"));
        self.roued.maxRot = {};
        self.roued.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.roued.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.roued.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.roued.rotTime = Utils.getNoNil(getXMLString(self.xmlFile, "vehicle.roued#rotTime"), 2)*1000;
        self.roued.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(self.xmlFile, "vehicle.roued#touchRotLimit"), 10))
    end;

    local rotationPartNodelamemi = Utils.indexToObject(self.rootNode, getXMLString(self.xmlFile, "vehicle.lamemi#index"));
    if rotationPartNodelamemi ~= nil then
        self.lamemi = {};
        self.lamemi.node = rotationPartNodelamemi;

        local x, y, z = Utils.getVectorFromString(getXMLString(self.xmlFile, "vehicle.lamemi#minRot"));
        self.lamemi.minRot = {};
        self.lamemi.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.lamemi.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.lamemi.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(self.xmlFile, "vehicle.lamemi#maxRot"));
        self.lamemi.maxRot = {};
        self.lamemi.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.lamemi.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.lamemi.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.lamemi.rotTime = Utils.getNoNil(getXMLString(self.xmlFile, "vehicle.lamemi#rotTime"), 2)*1000;
        self.lamemi.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(self.xmlFile, "vehicle.lamemi#touchRotLimit"), 10))
    end;
    
        local rotationPartNodel1lame = Utils.indexToObject(self.rootNode, getXMLString(self.xmlFile, "vehicle.l1lame#index"));
    if rotationPartNodel1lame ~= nil then
        self.l1lame = {};
        self.l1lame.node = rotationPartNodel1lame;

        local x, y, z = Utils.getVectorFromString(getXMLString(self.xmlFile, "vehicle.l1lame#minRot"));
        self.l1lame.minRot = {};
        self.l1lame.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.l1lame.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.l1lame.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(self.xmlFile, "vehicle.l1lame#maxRot"));
        self.l1lame.maxRot = {};
        self.l1lame.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.l1lame.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.l1lame.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.l1lame.rotTime = Utils.getNoNil(getXMLString(self.xmlFile, "vehicle.l1lame#rotTime"), 2)*1000;
        self.l1lame.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(self.xmlFile, "vehicle.l1lame#touchRotLimit"), 10))
    end;
    
        local rotationPartNoderipdent = Utils.indexToObject(self.rootNode, getXMLString(self.xmlFile, "vehicle.ripdent#index"));
    if rotationPartNoderipdent ~= nil then
        self.ripdent = {};
        self.ripdent.node = rotationPartNoderipdent;

        local x, y, z = Utils.getVectorFromString(getXMLString(self.xmlFile, "vehicle.ripdent#minRot"));
        self.ripdent.minRot = {};
        self.ripdent.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.ripdent.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.ripdent.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(self.xmlFile, "vehicle.ripdent#maxRot"));
        self.ripdent.maxRot = {};
        self.ripdent.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.ripdent.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.ripdent.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.ripdent.rotTime = Utils.getNoNil(getXMLString(self.xmlFile, "vehicle.ripdent#rotTime"), 2)*1000;
        self.ripdent.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(self.xmlFile, "vehicle.ripdent#touchRotLimit"), 10))
    end;

    local rotationPartNodel1haut = Utils.indexToObject(self.rootNode, getXMLString(self.xmlFile, "vehicle.l1haut#index"));
    if rotationPartNodel1haut ~= nil then
        self.l1haut = {};
        self.l1haut.node = rotationPartNodel1haut;

        local x, y, z = Utils.getVectorFromString(getXMLString(self.xmlFile, "vehicle.l1haut#minRot"));
        self.l1haut.minRot = {};
        self.l1haut.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.l1haut.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.l1haut.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(self.xmlFile, "vehicle.l1haut#maxRot"));
        self.l1haut.maxRot = {};
        self.l1haut.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.l1haut.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.l1haut.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.l1haut.rotTime = Utils.getNoNil(getXMLString(self.xmlFile, "vehicle.l1haut#rotTime"), 2)*1000;
     
     
        self.l1haut.pivotverin = Utils.indexToObject(self.rootNode, getXMLString(self.xmlFile, "vehicle.l1haut#pivotverin"));
    end;
    
        local rotationPartNodel1bas = Utils.indexToObject(self.rootNode, getXMLString(self.xmlFile, "vehicle.l1bas#index"));
    if rotationPartNodel1bas ~= nil then
        self.l1bas = {};
        self.l1bas.node = rotationPartNodel1bas;

        local x, y, z = Utils.getVectorFromString(getXMLString(self.xmlFile, "vehicle.l1bas#minRot"));
        self.l1bas.minRot = {};
        self.l1bas.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.l1bas.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.l1bas.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(self.xmlFile, "vehicle.l1bas#maxRot"));
        self.l1bas.maxRot = {};
        self.l1bas.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.l1bas.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.l1bas.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.l1bas.rotTime = Utils.getNoNil(getXMLString(self.xmlFile, "vehicle.l1bas#rotTime"), 2)*1000;
     
     
        self.l1bas.pivotverin = Utils.indexToObject(self.rootNode, getXMLString(self.xmlFile, "vehicle.l1bas#pivotverin"));
    end;
    
        local rotationPartNoderiphaut = Utils.indexToObject(self.rootNode, getXMLString(self.xmlFile, "vehicle.riphaut#index"));
    if rotationPartNoderiphaut ~= nil then
        self.riphaut = {};
        self.riphaut.node = rotationPartNoderiphaut;

        local x, y, z = Utils.getVectorFromString(getXMLString(self.xmlFile, "vehicle.riphaut#minRot"));
        self.riphaut.minRot = {};
        self.riphaut.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.riphaut.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.riphaut.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(self.xmlFile, "vehicle.riphaut#maxRot"));
        self.riphaut.maxRot = {};
        self.riphaut.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.riphaut.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.riphaut.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.riphaut.rotTime = Utils.getNoNil(getXMLString(self.xmlFile, "vehicle.riphaut#rotTime"), 2)*1000;
     
     
        self.riphaut.pivotverin = Utils.indexToObject(self.rootNode, getXMLString(self.xmlFile, "vehicle.riphaut#pivotverin"));
    end;
    
        local rotationPartNoderipbas = Utils.indexToObject(self.rootNode, getXMLString(self.xmlFile, "vehicle.ripbas#index"));
    if rotationPartNoderipbas ~= nil then
        self.ripbas = {};
        self.ripbas.node = rotationPartNoderipbas;

        local x, y, z = Utils.getVectorFromString(getXMLString(self.xmlFile, "vehicle.ripbas#minRot"));
        self.ripbas.minRot = {};
        self.ripbas.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.ripbas.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.ripbas.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(self.xmlFile, "vehicle.ripbas#maxRot"));
        self.ripbas.maxRot = {};
        self.ripbas.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.ripbas.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.ripbas.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.ripbas.rotTime = Utils.getNoNil(getXMLString(self.xmlFile, "vehicle.ripbas#rotTime"), 2)*1000;
     
     
        self.ripbas.pivotverin = Utils.indexToObject(self.rootNode, getXMLString(self.xmlFile, "vehicle.ripbas#pivotverin"));
    end;
    
    self.lmvg = {};
    self.lmvg.node = Utils.indexToObject(self.rootNode, getXMLString(self.xmlFile, "vehicle.lmvg#indexverin"));
    self.lmvg.tige = Utils.indexToObject(self.rootNode, getXMLString(self.xmlFile, "vehicle.lmvg#indextige"));
    self.lmvg.translationtige = Utils.indexToObject(self.rootNode, getXMLString(self.xmlFile, "vehicle.lmvg#translationtige"));
    local ax, ay, az = getWorldTranslation(self.lmvg.tige);
    local bx, by, bz = getWorldTranslation(self.lmvg.translationtige);
    self.lmvg.tigeDistance = Utils.vector3Length(ax-bx, ay-by, az-bz);
    
    self.lmvd = {};
    self.lmvd.node = Utils.indexToObject(self.rootNode, getXMLString(self.xmlFile, "vehicle.lmvd#indexverin"));
    self.lmvd.tige = Utils.indexToObject(self.rootNode, getXMLString(self.xmlFile, "vehicle.lmvd#indextige"));
    self.lmvd.translationtige = Utils.indexToObject(self.rootNode, getXMLString(self.xmlFile, "vehicle.lmvd#translationtige"));
    local ax, ay, az = getWorldTranslation(self.lmvd.tige);
    local bx, by, bz = getWorldTranslation(self.lmvd.translationtige);
    self.lmvd.tigeDistance = Utils.vector3Length(ax-bx, ay-by, az-bz);
    
    
    
    self.l1verin = {};
    self.l1verin.node = Utils.indexToObject(self.rootNode, getXMLString(self.xmlFile, "vehicle.l1verin#indexverin"));
    self.l1verin.tige = Utils.indexToObject(self.rootNode, getXMLString(self.xmlFile, "vehicle.l1verin#indextige"));
    self.l1verin.translationtige = Utils.indexToObject(self.rootNode, getXMLString(self.xmlFile, "vehicle.l1verin#translationtige"));
    local ax, ay, az = getWorldTranslation(self.l1verin.tige);
    local bx, by, bz = getWorldTranslation(self.l1verin.translationtige);
    self.l1verin.tigeDistance = Utils.vector3Length(ax-bx, ay-by, az-bz);
    
      
    self.ripverin = {};
    self.ripverin.node = Utils.indexToObject(self.rootNode, getXMLString(self.xmlFile, "vehicle.ripverin#indexverin"));
    self.ripverin.tige = Utils.indexToObject(self.rootNode, getXMLString(self.xmlFile, "vehicle.ripverin#indextige"));
    self.ripverin.translationtige = Utils.indexToObject(self.rootNode, getXMLString(self.xmlFile, "vehicle.ripverin#translationtige"));
    local ax, ay, az = getWorldTranslation(self.ripverin.tige);
    local bx, by, bz = getWorldTranslation(self.ripverin.translationtige);
    self.ripverin.tigeDistance = Utils.vector3Length(ax-bx, ay-by, az-bz);
    

end;

function cat140m:delete()

end;


function cat140m:mouseEvent(posX, posY, isDown, isUp, button)
end;

function cat140m:keyEvent(unicode, sym, modifier, isDown)

    if sym == Input.KEY_KP_8 then
    self.rotationMinplame= isDown;
    self.translationMin11= isDown;
    end;
    
    if sym == Input.KEY_KP_5 then
    self.rotationMaxplame= isDown;
    self.translationMax11= isDown;
    end;
    
    if sym == Input.KEY_n then
    self.rotationMinlamemi= isDown; 
    end;
    
    if sym == Input.KEY_m then
    self.rotationMaxlamemi= isDown;
    end;
    
    if sym == Input.KEY_KP_0 then
    self.rotationMinroueg= isDown;
    self.rotationMinroued= isDown;
    end;

    if sym == Input.KEY_KP_period then
    self.rotationMaxroueg = isDown;
    self.rotationMaxroued = isDown;
    end;
    
   if sym == Input.KEY_KP_7 then
        self.rotationMinl1lame= isDown;
        self.rotationMinl1haut= isDown;
        self.rotationMinl1bas= isDown;
        self.playHidraulic2 = not self.playHidraulic2;
    end;
    
    if sym == Input.KEY_KP_4 then
        self.rotationMaxl1lame = isDown;
        self.rotationMaxl1haut = isDown;
        self.rotationMaxl1bas= isDown;
        self.playHidraulic3 = not self.playHidraulic3;
    end;
        
    if sym == Input.KEY_KP_9 then
        self.rotationMinriphaut= isDown;
        self.rotationMinripdent= isDown;
        self.rotationMinripbas= isDown;
        self.playHidraulic2 = not self.playHidraulic2;
    end;
    
    if sym == Input.KEY_KP_6 then
        self.rotationMaxriphaut = isDown;
        self.rotationMaxripdent = isDown;
        self.rotationMaxripbas= isDown;
        self.playHidraulic3 = not self.playHidraulic3;
    end;
        



end;


function cat140m:update(dt)



    self.plameMoving = 0;
    self.l1hautMoving = 0;
    self.l1basMoving = 0;
    self.riphautMoving = 0;
    self.ripbasMoving = 0; 
    self.rouegMoving = 0;
    self.ripdentMoving = 0;
    self.rouedMoving = 0;
    self.lamemiMoving = 0;
    self.l1lameMoving = 0;
    
           for i, jointDesc in pairs(self.componentJoints) do
       setJointFrame(self.componentJoints[i].jointIndex, 0, self.componentJoints[i].jointNode);
    end;
    
    local doTranslate = self.translationMax11 or self.translationMin11
        if self.translationMax11 ~= nil and doTranslate then
        local x, y, z = getTranslation(self.translationPart11.node);
        local trans = {x,y,z};
        local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart11.maxTrans, self.translationPart11.minTrans, 3, self.translationPart11.transTime, dt, not self.translationMax11);
        setTranslation(self.translationPart11.node, unpack(newTrans));
    end;
    
    
    local doRotate = self.rotationMaxplame or self.rotationMinplame
        if self.plame ~= nil and doRotate then
        local x, y, z = getRotation(self.plame.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.plame.maxRot, self.plame.minRot, 3, self.plame.rotTime, dt, not self.rotationMaxplame);
        setRotation(self.plame.node, unpack(newRot));

    end;
    
        local doRotate = self.rotationMaxroueg or self.rotationMinroueg
        if self.roueg ~= nil and doRotate then
        local x, y, z = getRotation(self.roueg.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.roueg.maxRot, self.roueg.minRot, 3, self.roueg.rotTime, dt, not self.rotationMaxroueg);
        setRotation(self.roueg.node, unpack(newRot));
    end;
        local doRotate = self.rotationMaxroued or self.rotationMinroued
        if self.roued ~= nil and doRotate then
        local x, y, z = getRotation(self.roued.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.roued.maxRot, self.roued.minRot, 3, self.roued.rotTime, dt, not self.rotationMaxroued);
        setRotation(self.roued.node, unpack(newRot));
    end;
    
    local doRotate = self.rotationMaxlamemi or self.rotationMinlamemi
        if self.lamemi ~= nil and doRotate then
        local x, y, z = getRotation(self.lamemi.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.lamemi.maxRot, self.lamemi.minRot, 3, self.lamemi.rotTime, dt, not self.rotationMaxlamemi);
        setRotation(self.lamemi.node, unpack(newRot));
    end;
    
    local doRotate = self.rotationMaxl1lame or self.rotationMinl1lame
        if self.l1lame ~= nil and doRotate then
        local x, y, z = getRotation(self.l1lame.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.l1lame.maxRot, self.l1lame.minRot, 3, self.l1lame.rotTime, dt, not self.rotationMaxl1lame);
        setRotation(self.l1lame.node, unpack(newRot));        
    end;
    
        local doRotate = self.rotationMaxripdent or self.rotationMinripdent
        if self.ripdent ~= nil and doRotate then
        local x, y, z = getRotation(self.ripdent.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.ripdent.maxRot, self.ripdent.minRot, 3, self.ripdent.rotTime, dt, not self.rotationMaxripdent);
        setRotation(self.ripdent.node, unpack(newRot));        
    end;
    

               local doRotate = self.rotationMaxl1haut or self.rotationMinl1haut
        if self.l1haut ~= nil and doRotate then
        local x, y, z = getRotation(self.l1haut.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.l1haut.maxRot, self.l1haut.minRot, 3, self.l1haut.rotTime, dt, not self.rotationMaxl1haut);
        setRotation(self.l1haut.node, unpack(newRot));
        
    end;
                   local doRotate = self.rotationMaxl1bas or self.rotationMinl1bas
        if self.l1bas ~= nil and doRotate then
        local x, y, z = getRotation(self.l1bas.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.l1bas.maxRot, self.l1bas.minRot, 3, self.l1bas.rotTime, dt, not self.rotationMaxl1bas);
        setRotation(self.l1bas.node, unpack(newRot));
        
    end;
                   local doRotate = self.rotationMaxriphaut or self.rotationMinriphaut
        if self.riphaut ~= nil and doRotate then
        local x, y, z = getRotation(self.riphaut.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.riphaut.maxRot, self.riphaut.minRot, 3, self.riphaut.rotTime, dt, not self.rotationMaxriphaut);
        setRotation(self.riphaut.node, unpack(newRot));
        
    end;
                   local doRotate = self.rotationMaxripbas or self.rotationMinripbas
        if self.ripbas ~= nil and doRotate then
        local x, y, z = getRotation(self.ripbas.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.ripbas.maxRot, self.ripbas.minRot, 3, self.ripbas.rotTime, dt, not self.rotationMaxripbas);
        setRotation(self.ripbas.node, unpack(newRot));
        
    end;
    
    if self.lmvg ~= nil and self.plame ~= nil then
        local ax, ay, az = getWorldTranslation(self.lmvg.node);
        local bx, by, bz = getWorldTranslation(self.plame.pivotverin);
        local x, y, z = worldDirectionToLocal(getParent(self.lmvg.node), bx-ax, by-ay, bz-az);
        setDirection(self.lmvg.node, x*-1, y*-1, z*-1, 0, 1, 0);
        if self.lmvg.tige ~= nil then
            local distance = Utils.vector3Length(ax-bx, ay-by, az-bz);
            setTranslation(self.lmvg.tige, 0, 0, (distance-self.lmvg.tigeDistance)*-1);
        end;
    end;
    
    if self.lmvd ~= nil and self.plame ~= nil then
        local ax, ay, az = getWorldTranslation(self.lmvd.node);
        local bx, by, bz = getWorldTranslation(self.plame.pivotverin2);
        local x, y, z = worldDirectionToLocal(getParent(self.lmvd.node), bx-ax, by-ay, bz-az);
        setDirection(self.lmvd.node, x*-1, y*-1, z*-1, 0, 1, 0);
        if self.lmvd.tige ~= nil then
            local distance = Utils.vector3Length(ax-bx, ay-by, az-bz);
            setTranslation(self.lmvd.tige, 0, 0, (distance-self.lmvd.tigeDistance)*-1);
        end;
    end;

    
    if self.l1verin ~= nil and self.l1bas ~= nil then
        local ax, ay, az = getWorldTranslation(self.l1verin.node);
        local bx, by, bz = getWorldTranslation(self.l1bas.pivotverin);
        local x, y, z = worldDirectionToLocal(getParent(self.l1verin.node), bx-ax, by-ay, bz-az);
        setDirection(self.l1verin.node, x*-1, y*-1, z*-1, 0, 1, 0);
        if self.l1verin.tige ~= nil then
            local distance = Utils.vector3Length(ax-bx, ay-by, az-bz);
            setTranslation(self.l1verin.tige, 0, 0, (distance-self.l1verin.tigeDistance)*-1);
        end;
    end;

    if self.ripverin ~= nil and self.ripbas ~= nil then
        local ax, ay, az = getWorldTranslation(self.ripverin.node);
        local bx, by, bz = getWorldTranslation(self.ripbas.pivotverin);
        local x, y, z = worldDirectionToLocal(getParent(self.ripverin.node), bx-ax, by-ay, bz-az);
        setDirection(self.ripverin.node, x*-1, y*-1, z*-1, 0, 1, 0);
        if self.ripverin.tige ~= nil then
            local distance = Utils.vector3Length(ax-bx, ay-by, az-bz);
            setTranslation(self.ripverin.tige, 0, 0, (distance-self.ripverin.tigeDistance)*-1);
        end;
    end;


end;
      


function cat140m:draw()
--g_currentMission:addExtraPrintText("Touche o: bloquer roues");
g_currentMission:addExtraPrintText("KP7/KP4:front blade-KP9/KP6:ripper");
g_currentMission:addExtraPrintText("KP8/KP5: main blade");
g_currentMission:addExtraPrintText("Touche 0/.  : Articulate Body");
g_currentMission:addExtraPrintText("n/m: Turn Main Blade");

end;

function cat140m:validateAttacherJoint(implement, jointDesc, dt)
    return true;
end;
